#include <stdio.h>  
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <libharkio3.h>

#define  PATH_LEN     1024     // file path 最大長




void help(void)
{
	printf("                                                                    \n");
	printf("                                                                    \n");
	printf("[NAME:]                                                             \n");
	printf("  harktoolcli-conv-tf                                               \n");
	printf("                                                                    \n");
	printf("[Description:]                                                      \n");
	printf("  Convert the old file transfer function                            \n");
	printf("                                                                    \n");
	printf("[Usage :]                                                           \n");
    printf("  harktoolcli-conv-tf [Argument]                                    \n");
	printf("                                                                    \n");
    printf("[Argument :]                                                        \n");
    printf( "  -l : Localization transfer file(Binary) or NULL  (-l loc.tf)     \n");
    printf( "  -s : Separation transfer file(Binary)   or NULL  (-s sep.tf )    \n");
    printf( "  -o : output transfer file(zip file)              (-o output.zip) \n");
	printf("                                                                    \n");
	printf(" - Localization , Separation file specify either or  both.          \n");

}









int main(int argc, char **argv)
{

	int option;
	int result;
	char *loctfpath = NULL;
	char *septfpath= NULL;
	char *outfile= NULL;
	
	harkio_TransferFunction *tf = NULL;


	//argument check
    if(argc < 2)
    {
		harkio_Log_printf(harkio_Log_Error , "argument error!!" );
        help();
		exit(EXIT_FAILURE);
    }


 
 
    // parse option
    while((option = getopt(argc, argv, "o:l:s:")) != -1)
    {
        switch(option)
        {
            case 'l':
            loctfpath = (char *)malloc( strlen(optarg) + 1);
            memset( loctfpath  , '\0' , strlen(optarg) + 1 );
            memcpy( loctfpath , optarg, strlen(optarg));

            break;

            case 's':
            septfpath = (char *)malloc(strlen(optarg) + 1);
            memset( septfpath  , '\0' , strlen(optarg) + 1 );
            memcpy( septfpath , optarg, strlen(optarg));
            break;

            case 'o':
            outfile = (char *)malloc(strlen(optarg) + 1);
            memset( outfile  , '\0' , strlen(optarg) + 1 );
            memcpy( outfile , optarg, strlen(optarg));
            break;

            case '?':
            help();
			exit(EXIT_FAILURE);
        }
    }



	printf("loctfpath=%s\n",loctfpath);

	result = libharkio3_TransferFunction_readlibhakio2( &tf , loctfpath ,  septfpath);

	if( result ==  EXIT_FAILURE )
	{
	    harkio_TransferFunction_delete(&tf);
		harkio_Log_printf(harkio_Log_Error , "libharkio3_TransferFunction_readlibhakio2 error" );
		exit(EXIT_FAILURE);
	}



	//write zip file
	harkio_TransferFunction_write( tf , outfile , "transfer function"); 


	printf("SUCCESS\n");
	printf(" output file : %s\n",outfile);

    harkio_TransferFunction_delete(&tf);
	if( loctfpath !=NULL) free(loctfpath);
	if( septfpath !=NULL) free(septfpath);
	if( outfile   !=NULL) free(outfile);
	
    exit(EXIT_SUCCESS);


}//func end


