#include <stdio.h>  
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <libharkio3.h>







void help(void)
{
	printf("                                                             \n");
	printf("                                                             \n");
	printf("[NAME:]                                                      \n");
	printf("  harktoolcli-mat2csv                                        \n");
	printf("                                                             \n");
	printf("[Description:]                                               \n");
    printf("  Convert csv file from mat file                             \n");
	printf("                                                             \n");
	printf("[Usage :]                                                    \n");
    printf(" harktoolcli-mat2csv filename(mat file) -o output-filename]  \n");
	printf("                                                             \n");
    printf("[options]                                                    \n");
    printf( "  -o : output file        (-o output.csv)                   \n");
	printf("                                                             \n");
}








int main(int argc, char **argv)
{


    int    i_data;
    float  f_data;
    int    option;
    char   strData[20];
    int    matrix_type;
    char   infile[1024];
    char   outfile[1024];
    char   tag[33];
    char   type[33];
    int    dim;
    int    rows;
    int    cols;
    FILE   *fp  = NULL;
    FILE   *fp1 = NULL;
    COMPLEX_TYPE  c_data;
	int    row,col;


    if(argc < 2)
    {
        printf("argument error!!\n\n");
        help();
        exit(EXIT_FAILURE);
    }


    memset(outfile ,'\0', sizeof(outfile) );
    memset(infile  ,'\0', sizeof(infile) );

    strcpy(infile , argv[1]);

    // parse option
    while((option = getopt(argc, argv, "o:")) != -1)
    {
        switch(option)
        {
            case 'o':
            strcpy(outfile, optarg);
            break;

            case '?':
            help();
            exit(EXIT_FAILURE);
        }
    }




    if ((fp = fopen( infile , "r")) == NULL) 
    {
        printf("input file open error!!\n");
        exit(EXIT_FAILURE);
    }


    if(strlen(outfile) != 0)
    {
        if ((fp1 = fopen( outfile, "w")) == NULL) 
        {
            printf("output file open error!!\n");
            exit(EXIT_FAILURE);
        }
    }


    memset(tag ,'\0', sizeof(tag) );
    memset(type,'\0', sizeof(type));



    fread(tag  ,32,1,fp);
    fread(type ,32,1,fp);
    fread(&dim ,4 ,1,fp);
    fread(&rows,4 ,1,fp);
    fread(&cols,4 ,1,fp);

    matrix_type = harkio_CheckType(type);

    switch(matrix_type)
    {
     case INT32:
     	for( row=0 ; row< rows; row++)
     	{
			for( col=0 ; col < cols ; col++)
			{     	
				fread(&i_data , 4 ,1,fp);

				if(strlen(outfile) != 0)
				{
					if(col == cols-1)
					{
						sprintf(strData , "%d\n" , i_data );
					}
					else
					{
						sprintf(strData , "%d," , i_data );
					}
					
					fwrite( strData , strlen(strData), 1, fp1);
				}
				else
				{
					if(col == cols-1)
					{
					   printf("%d\n", i_data);
					}
					else
					{
					   printf("%d,", i_data);
					}
				}
			}
        }

        break;

     case FLOAT32:
     	for( row=0 ; row< rows; row++)
     	{
			for( col=0 ; col < cols ; col++)
			{     	
				fread(&f_data , 4 ,1,fp);

				if(strlen(outfile) != 0)
				{
					if(col == cols-1)
					{
						sprintf(strData , "%f\n" , f_data );
					}
					else
					{
						sprintf(strData , "%f," , f_data );
					}
					fwrite( strData , strlen(strData), 1, fp1);
				}
				else
				{
					if(col == cols-1)
					{
						printf("%f\n", f_data);
					}
					else
					{
						printf("%f,", f_data);
					}
				 }
			}
        }

        break;

     case COMPLEX:
     	for( row=0 ; row< rows; row++)
     	{
			for( col=0 ; col < cols ; col++)
			{     	
		        fread(&c_data , 8 ,1,fp);

		        if(strlen(outfile) != 0)
		        {
					if(col == cols-1)
					{
				        sprintf(strData , "%f,%f\n" , crealf(c_data) , cimagf(c_data) );
					}
					else
					{
				        sprintf(strData , "%f,%f," , crealf(c_data) ,cimagf(c_data) );
					}
			        fwrite( strData , strlen(strData), 1, fp1);
		        }
		        else
		        {
					if(col == cols-1)
					{
						printf("%f,%f\n", crealf(c_data) ,cimagf(c_data));
					}
					else
					{
		             	printf("%f,%f,", crealf(c_data) ,cimagf(c_data));
					}
		         }
			}
		}
        break;
    }


    if(fp1!=NULL)
    {
        fclose(fp1);
    }

    fclose(fp);


	printf("SUCCESS\n");
	printf(" output file : %s\n",outfile);

    exit(EXIT_SUCCESS);

}

